(($) ->
	
	WhereYat = (options, completionCallback) ->
		@error = false
		@options = $.extend {}, options
		@completion = completionCallback
		@nodes = []
		@parse()
		@render()
		return
	
	WhereYat.prototype.locate = ->
		$.ajax
			method: 'GET'
			url: 'https://ip.wherey.at/'
			success: (data, status, jqXHR) =>
				if data.status == 'ok'
					@location = 
						lat: data.latitude
						lng: data.longitude
					@render()
				else if data.status == 'not_found'
					# could not locate record for this ip address
					@render { error: true }
				else
					# something went wrong
					@render { error: true }
				return
			error: (jqXHR, textStatus, errorThrown) =>
				# something went wrong
				# TODO: add fallback?
				@render { error: true }
				return
		return

	WhereYat.prototype.parse = ->
		$(@options.className).each (index, element) =>
			@nodes.push element
		return
	
	WhereYat.prototype.render = (options = {}) ->
		unless @location? or options.error
			@locate()
			$(@nodes).each (index, element) =>
				$el = $ element
				$el.addClass "#{@options.classPrefix}locating"
			return
		$(@nodes).each (index, element) =>
			$el = $ element
			$el.removeClass "#{@options.classPrefix}locating"
			if options.error
				$el.addClass "#{@options.classPrefix}error"
			else
				location =
					lat: $el.data(@options.latitudeData)
					lng: $el.data(@options.longitudeData)
				userDistance = @distance(location, @location)
				distanceClass = @options.maxDistance
				for klass, distance of @options.distances
					if distance >= userDistance
						distanceClass = klass
						break
				$el.addClass "#{@options.classPrefix}#{distanceClass}"
		if @completion?
			@completion()
		return
	
	WhereYat.prototype.distance = (from, to) ->
		lat1 = from.lat
		lat2 = to.lat
		lon1 = from.lng
		lon2 = to.lng
		radlat1 = Math.PI * lat1 / 180
		radlat2 = Math.PI * lat2 / 180
		radlon1 = Math.PI * lon1 / 180
		radlon2 = Math.PI * lon2 / 180
		theta = lon1-lon2
		radtheta = Math.PI * theta / 180
		dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta)
		dist = Math.acos(dist)
		dist = dist * 180 / Math.PI
		dist = dist * 60 * 1.1515
		if @options.units == "kilometers"
			dist = dist * 1.609344
		dist
	
	$.whereyat = (options, completionCallback) ->
		options = $.extend {}, $.whereyat.options, options
		new WhereYat(options, completionCallback)
	
	$.whereyat.options =
		className: '.whereyat'
		classPrefix: 'yat-'
		latitudeData: 'yatLat'
		longitudeData: 'yatLong'
		maxDistance: 'xl'
		units: 'miles'
		distances:
			'xs': 75
			'sm': 200
			'md': 750
			'lg': 1250
	
	return
) jQuery